 /*
  * Khoros: $Id: vsvpsf.h,v 1.2 1992/03/20 23:09:49 dkhoros Exp $
  */

 /*
  * $Log: vsvpsf.h,v $
 * Revision 1.2  1992/03/20  23:09:49  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vsvpsf.h
 >>>>            Author: Scott Wilson
 >>>> Date Last Updated: Mon Jan  6 14:21:32 1992
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vsvpsf_h_
#define _vsvpsf_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    vsvpsf Argument Structure
*
****************************************************************/

typedef struct _vsvpsf  {

/*
 *  input (degraded) image (Required infile)
 */
char	*i_file;	/* input (degraded) image FILENAME */
int	 i_flag;	/* input (degraded) image FLAG */

/*
 *  quantized SVPSF (Required infile)
 */
char	*psf_file;	/* quantized SVPSF FILENAME */
int	 psf_flag;	/* quantized SVPSF FLAG */

/*
 *  filter threshold (Required float)
 */
float	 t_float;	/* filter threshold FLOAT */
int	 t_flag;   	/* filter threshold FLAG */

/*
 *  output (restored) image (Required outfile)
 */
char	*o_file;	/* output (restored) image FILENAME */
int	 o_flag;	/* output (restored) image FLAG */

}  vsvpsf_struct;

vsvpsf_struct *vsvpsf;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
